import json
from collections import namedtuple
from .supportutil import *
from json import JSONEncoder


def run():
    open_api_version = "3.0.1"
    definition_info = dict(title="Travel Search API", description="API for perform travel booking", version="1.0.0")
    definition_tags = [dict(name="Travlinq Service", description="API for travel products")]
    definition_paths = dict()
    definition_schemas = dict()
    definitions_dir = "definitionDir/"
    definitions = get_all_definitions(definitions_dir)
    url_list = []
    for definition in definitions:
        url_list.append(definition["servers"][0]["url"])
    base_url = validate_urls(url_list)
    definition_servers = [dict(url=base_url)]
    if base_url == "":
        raise Exception("Definition urls are missed match (Hint : Different domain names)")

    for i in range(0, len(definitions)):
        definition = definitions[i]
        definition_path_prefix = get_url_path(definition["servers"][0]["url"])
        if i == 0:
            for path in definition["paths"].keys():
                definition_paths[definition_path_prefix + path] = definition["paths"][path]
                # print(path)
            definition_schemas = definition["components"]["schemas"]
        else:
            merge_definition(definition_schemas, definition_paths, definition, definition_path_prefix)

    # print(definition_paths)
    # print(definition_schemas)
    final_components = dict(schemas=definition_schemas)
    final_definition =  dict(openapi=open_api_version, info=definition_info,
                                              servers=definition_servers, tags=definition_tags, paths=definition_paths,
                                              components=final_components)

    #print(final_definition)

    final_definition_json=json.dumps(final_definition)
    print(final_definition_json)
    with open("finalJsonDir/travel_product.json", "w") as outfile:
        outfile.write(final_definition_json)
